#include <string.h>
#include <stdio.h>
#include <conio.h>
#include <io.h>
#include <vector>
#include <string>
using namespace std;
//    
#define TYPE_INT 2
#define TYPE_SMALLTEXT 50
#define TYPE_TEXT 200
//  
#define AUTO 1
#define ALL 1
#define EXACTLY 1
/*************************************************************
*
*	    
*
*************************************************************/
class CColum
{
	string name;					// 
	unsigned int length;			// 
	bool autoit;					//	
public:
	CColum(string&ss,unsigned int len)//,
		{
			name=ss;
			autoit=false;
			length=len;
		};
	CColum(string&ss,unsigned int len,int aa)//,,
		{
			name=ss;
			autoit=true;
			length=len;
		};
	bool isauto()
		{
			if(autoit)return true;
				return false;
		};
	string&getname()
		{
			return name;
		};
	unsigned int gettype()
		{
			return length;
		};
};
/*************************************************************
*
*	      
*
*************************************************************/
class CRecord
{
	string name;					// 
	string data;					//	
	unsigned int type;				// 	
public:
	void setname(string&nam)
		{name=nam;};
	void setdata(string&dat){data=dat;};
	void settype(unsigned int&typ){type=typ;};
	string&getname(){return name;};
	string&getdata(){return data;};
	unsigned int gettype(){return type;};
};
/*************************************************************
*
*	    
*
*************************************************************/
class CRow
{
	vector<CRecord>rec;			// 
	int flag;					// 
	string name;				// 
	unsigned int type;			// 
public:
	CRow(){flag=0;};
	void reset()				
	{
		rec.clear();			
	}
	void setrow(vector<CRecord>&v){rec=v;};
	vector<CRecord>&getrow(){return rec;}
	string operator[](string ss)//     
		{
			int size=rec.size();
			for(int i=0;i<size;i++)
			{
				if(ss==rec[i].getname())
						return rec[i].getdata(); 
			}
			return "Empty";
		};
	int operator()(string ss)//      
	{
			int size=rec.size();
			for(int i=0;i<size;i++)
			{
				if(ss==rec[i].getname())
						return rec[i].gettype(); 
			}
			return 0;
	};
	CRow&operator()(string ss,unsigned int typ)//1-     
	{
		flag=1;									//     operation= 
		name=ss;								//  	
		type=typ;								//  
		return *(this);							//    
	};
	void operator=(string dat)//2-     
	{
		if(flag)								
		{	
			CRecord rr;							//   		
			rr.setname(name);
			rr.setdata(dat);
			rr.settype(type);
			rec.push_back(rr);
		}
		flag=0;
	};
};
/********************************************************
*
*       
*
********************************************************/
class CTable
{
	vector<CColum> types;		//   
	string filename;			//   	
	fpos_t startdata;			//   
	int corrow;					//  id  		
	char buf1[55];				// 
/////////////////////////////////////////////////////////
//   
//
private:
	int getfullsize()
	{
		int fullsize,j;
		_asm mov j,0
		_asm mov fullsize,0
		for(;j<(int)types.size();)
		{
			fullsize+=types[j].gettype();
			_asm inc j;
		}
		return fullsize;
	};
public:
///////////////////////////////////////////////////////
//
//  ,   
//        
//:
//"", ,  , id ,
//  
//
	CTable(string&filename)
	{
		corrow=0;
		startdata=0;
		this->filename=filename;
		int i;
		unsigned int i1,i2;
		if(Is())
		{
			FILE*file;
			const char *buf=filename.c_str();
			if(!(file=fopen(buf,"rb")))
 				return;
			rewind(file);
			fseek(file,2,0);
			fread(&buf1[0],1,1,file);
			int howmany=(unsigned char)buf1[0];
			fread(&buf1[0],1,1,file);
			int autoinc=(unsigned char)buf1[0];
			fread(&buf1[0],1,2,file);
			corrow=256*(unsigned char)buf1[0]+(unsigned char)buf1[1];
			unsigned int ty;
			int len;
			char*buf3;
			__asm
			{
				mov i,0
				loop_constractor:			
			}
				fread(buf1,1,2,file);
				i1=(unsigned char)buf1[0];
				i2=(unsigned char)buf1[1];
				_asm
				{
					PUSH EAX
					MOV  EAX,i1
					SHL  EAX,8
					ADD  EAX,i2
					MOV  ty,EAX
					POP  EAX
				}
				fread(buf1,1,1,file);
				len=(unsigned char)buf1[0];
				buf3=new char[len+1];
				buf3[len]=0;	
				fread(buf3,1,len,file);
				if(autoinc==i)
					types.push_back(CColum(string(buf3),ty,AUTO));
				else 
					types.push_back(CColum(string(buf3),ty));
				delete[]buf3;
				__asm
				{
					inc i
					mov eax,i
					cmp eax,howmany
					jc loop_constractor
				}
			fgetpos(file,&startdata);
			fclose(file);
		}
	}
////////////////////////////////////////////////////////////
//  
//
//   2 
//   
//
	bool Is()
	{
		FILE*file;
		const char *buf=filename.c_str();
		if(!(file=fopen(buf,"rb")))
 			return false;
		rewind(file);
		fread(buf1,1,2,file);
		if(feof(file))return false;
		if((buf1[0]!='A')||(buf1[1]!='B'))
			{fclose(file);return false;}
		fread(buf1,1,1,file);
		if(buf1[0]!=0)
			{fclose(file);return true;}
		fclose(file);
		return true;
	}
//////////////////////////////////////////////////////////
//  
//
	vector<CColum> GetCap()
	{
		return types;
	}
//////////////////////////////////////////////////////////
//  
//
//        
//	       
//
	int getrows()
	{
		FILE*file;
		int idata;
		const char *buf=filename.c_str();
		if(!(file=fopen(buf,"ab")))
			return 0;
		int fullsize=getfullsize();
		idata=(filelength(fileno(file))-startdata)/fullsize;
		fclose(file);
		return idata;
	}

//////////////////////////////////////////////////////////
// 
//
//      
//
	bool CreateTable(vector<CColum>&type)
	{
		FILE*file;
		int i;
		int num=type.size();
		const char *buf=filename.c_str();
		if(!(file=fopen(buf,"w+b")))
			return false;
		int autoinc;
		_asm mov autoinc,0
		rewind(file);
		buf1[0]='A';
		buf1[1]='B';
		fwrite(buf1,1,2,file);
		buf1[0]=num;
		fwrite(buf1,1,1,file);
		for(int j=0;j<num;j++)
			if(type[j].isauto())
			{
				autoinc=j;
				break;
			}
		buf1[0]=autoinc;
		fwrite(buf1,1,1,file);
		buf1[0]=0;
		buf1[1]=0;
		fwrite(buf1,1,2,file);
		string ss;
		int len;
		__asm
		{
			mov i,0
			loop_create:			
		}

			buf1[0]=type[i].gettype()/256;
			buf1[1]=type[i].gettype()%256;
			fwrite(buf1,1,2,file);
			ss=type[i].getname();	
			len=ss.length();
			buf1[0]=len;
			fwrite(buf1,1,1,file);
			fwrite(ss.c_str(),1,len,file);
		__asm
		{
			inc i
			mov eax,i
			cmp eax,num
			jc loop_create
		}
		types=type;
		fgetpos(file,&startdata);
		fclose(file);
		return true;
	}
////////////////////////////////////////////////////////////
//   
//
bool AddRow(CRow&rr)
	{
		FILE*file;
		const char *buf=filename.c_str();
		if(!(file=fopen(buf,"r+b")))
			return false; 
		char buf2[3];
		fseek(file,4,0);
		corrow++;
		buf2[0]=corrow/256;	
		buf2[1]=corrow%256;
		fwrite(buf2,1,2,file);
		fseek(file,0,2);
		int size=types.size();
		int i;
		string data;
		unsigned int typ;
		int idata;
		__asm mov i,0
		for(;i<size;)
		{
			data=rr[types[i].getname()];
			typ=types[i].gettype();
			switch(typ)
			{   
				case TYPE_INT:
					idata=atoi(data.c_str());
					if(types[i].isauto())
					{
						fpos_t cur;
						fgetpos(file,&cur);
						int i=types.size();
						int fullsize=getfullsize();
						idata=corrow-1;
					}
					buf1[0]=idata/256;	
					buf1[1]=idata%256;
					fwrite(buf1,1,2,file);
				;break;	
				case TYPE_SMALLTEXT:case TYPE_TEXT:
					strcpy(buf1,data.c_str());
					for(int j=data.length();j<(int)types[i].gettype();j++)
						buf1[j]=0;
					fwrite(buf1,1,types[i].gettype(),file);
				;break;	
			};
			_asm inc i
		}
		fclose(file);
		return true;
 }
////////////////////////////////////////////////////////////
//        
//
//nam- 
//dat-
//
void GetStr(vector<CRow>&finded,string nam,string dat)
	{
		FILE*file;
		const char *buf=filename.c_str();
		if(!(file=fopen(buf,"rb")))
			return;
		fseek(file,startdata,0);
		int all=types.size();
		int i;
		int type;
		string data;
		string name;
		CRow ww;
		while(1)
		{
			ww.reset();	
			_asm mov i,0
			for(;i<all;)
			{
				type=types[i].gettype();
				if(type==TYPE_INT)
				{
					fread(buf1,1,type,file);
					unsigned int i1=(unsigned char)buf1[0];
					unsigned int i2=(unsigned char)buf1[1];
					unsigned int s;
					_asm
					{
						PUSH EAX
						MOV  EAX,i1
						SHL  EAX,8
						ADD  EAX,i2
						MOV  s,EAX
						POP  EAX
					}
					itoa(s,buf1,10);		
				}
				else
				{
					fread(buf1,1,type,file);
					buf1[type]=0;
				}
				if(feof(file))return;
				ww(types[i].getname(),type)=string(buf1);
				_asm inc i
			}
			if(strstr(ww[nam].c_str(),dat.c_str()))
			{
				finded.push_back(ww);
			}	
		}
		fclose(file);
		return;
	}
////////////////////////////////////////////////////////////
//       
//
//nam- 
//dat-
//
void GetCmp(vector<CRow>&finded,string nam,string dat)
	{
		FILE*file;
		const char *buf=filename.c_str();
		if(!(file=fopen(buf,"rb")))
			return;
		fseek(file,startdata,0);
		int all=types.size(),i,type;
		string data,name;
		CRow ww;
		while(1)
		{
			ww.reset();
			_asm mov i,0
			for(;i<all;)
			{
				type=types[i].gettype();
				if(type==TYPE_INT)
				{
					fread(buf1,1,type,file);
 					unsigned int i1=(unsigned char)buf1[0];
					unsigned int i2=(unsigned char)buf1[1];
					unsigned int s;
					_asm
					{
						PUSH EAX
						MOV  EAX,i1
						SHL  EAX,8
						ADD  EAX,i2
						MOV  s,EAX
						POP  EAX
					}
					itoa(s,buf1,10);
				}
				else
				{
					fread(buf1,1,type,file);
					buf1[type]=0;
				}
				if(feof(file))return;
				ww(types[i].getname(),type)=string(buf1);
				_asm inc i
			}
			if(ww[nam]==dat)
			{
				finded.push_back(ww);
			}	
		}
		fclose(file);
		return ;
}
//////////////////////////////////////////////////////////////
//     
// 
//
//nam- 
//dat-
//
bool DeleteData(string nam,string dat)
	{
		FILE*file;
		const char *buf=filename.c_str();
		if(!(file=fopen(buf,"r+b")))
			return false;
		fseek(file,startdata,0);
		int i,j;
		int size=types.size();
		int fullsize=getfullsize();
		int type;
		while(1)
		{
			CRow ww;
			_asm mov i,0
			for(;i<size;)
			{
				type=types[i].gettype();
				if(type==TYPE_INT)
				{
					fread(buf1,1,type,file);
 					unsigned int i1=(unsigned char)buf1[0];
					unsigned int i2=(unsigned char)buf1[1];
					unsigned int s;
					_asm
					{
						PUSH EAX
						MOV  EAX,i1
						SHL  EAX,8
						ADD  EAX,i2
						MOV  s,EAX
						POP  EAX
					}
					itoa(s,buf1,10);
				}
				else
				{
					fread(buf1,1,type,file);
					buf1[type]=0;
				}
				if(feof(file))break;
				ww(types[i].getname(),type)=string(buf1);
			_asm inc i
			}

			if(feof(file))break;

			if(ww[nam]==dat)
			{
				fpos_t start,end;
				fgetpos(file,&end);
				start=end-fullsize;
				char*buf3=new char[fullsize];
				unsigned int idata=0;
				for(j=end;j<filelength(fileno(file))-startdata;j+=fullsize)
				{
					fread(buf3,1,fullsize,file);
					fseek(file,-2*fullsize,SEEK_CUR);
					fwrite(buf3,1,fullsize,file);
					fseek(file,fullsize,SEEK_CUR);
				}
				chsize(fileno(file),filelength(fileno(file))-fullsize);	
				rewind(file);
				fseek(file,start,0);
				delete[]buf3;
			}	
			if(feof(file))break;
		}
		fclose(file);
		return true;
	}
///////////////////////////////////////////////////////////////////////
//   
//     
//
//nam- 
//dat-
//
bool ChangeData(CRow&rr,string nam,string dat)
	{
		FILE*file;
		const char *buf=filename.c_str();
		if(!(file=fopen(buf,"r+b")))
			return false;
		fseek(file,startdata,0);
		int all=types.size();
		int i;
		int type;
		string data;
		string name;
		fpos_t poss;
		char buf2[4];
		while(1)
		{
			if(feof(file))break;
			CRow ww;
			fgetpos(file,&poss);
			__asm
			{
				mov i,0
				loop_change:			
			}
				type=types[i].gettype();
				if(type==TYPE_INT)
				{
					fread(buf1,1,type,file);
 					unsigned int i1=(unsigned char)buf1[0];
					unsigned int i2=(unsigned char)buf1[1];
					unsigned int s;
					_asm
					{
						PUSH EAX
						MOV  EAX,i1
						SHL  EAX,8
						ADD  EAX,i2
						MOV  s,EAX
						POP  EAX
					}
					itoa(s,buf2,10);
					strcpy(buf1,buf2);
					buf1[3]=0;
				}
				else
				{
					fread(buf1,1,type,file);
					buf1[type]=0;
				}
				if(feof(file))break;
				ww(types[i].getname(),type)=string(buf1); 
				__asm
				{
					inc i
					mov eax,i
					cmp eax,all
					jc loop_change
				}
			if(ww[nam]==dat)
			{
				fclose(file);
				const char *buf=filename.c_str();
				if(!(file=fopen(buf,"r+b")))
					return false;
				fseek(file,poss,0);
				__asm
				{
					mov i,0
					loop_ChangeData:			
				}
			
					type=types[i].gettype();
					if(type==TYPE_INT)
					{
						if(types[i].isauto())
							fseek(file,poss+TYPE_INT,0);
						else
						{
							buf1[0]=atoi(rr[types[i].getname()].c_str())/256;			
							buf1[1]=atoi(rr[types[i].getname()].c_str())%256;
							fwrite(buf1,1,TYPE_INT,file);
						}
					}
					else
					{
						strcpy(buf1,rr[types[i].getname()].c_str());
						for(int j=rr[types[i].getname()].size();j<type;j++)
							buf1[j]=0;
						int kk=fwrite(buf1,1,type,file);
					}
				__asm
				{
					inc i
					mov eax,i
					cmp eax,all
					jc loop_ChangeData
				}
				fclose(file);	
				return true;
	
			}
			getch();
	}
		fclose(file);	
	return false;
	}

};
