// ModelList.cpp : implementation file
//
#include "stdafx.h"
#include "Autolog.h"
#include "ModelList.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CModelList::CModelList(CWnd* pParent /*=NULL*/)
	: CDialog(CModelList::IDD, pParent)
{
	//{{AFX_DATA_INIT(CModelList)
	m_edit = _T("");
	//}}AFX_DATA_INIT
}
void CModelList::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CModelList)
	DDX_Control(pDX, IDC_LIST1, m_list);
	DDX_Text(pDX, IDC_EDIT1, m_edit);
	DDV_MaxChars(pDX, m_edit, 50);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CModelList, CDialog)
	//{{AFX_MSG_MAP(CModelList)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_LBN_SELCHANGE(IDC_LIST1, OnSelchangeList1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
/////////////////////////////////////////////////////////////////////////////
//    
//
void CModelList::OnButton1() 
{
	UpdateData();
	if(m_edit.GetLength()<=0){MessageBox("   ","Attention");return;}
	CString ss;
	for(int i=0;i<m_list.GetCount();i++)			//     ,   
	{	m_list.GetText(i,ss);
		if(!ss.CompareNoCase(m_edit.GetBuffer(100)))
		{
			MessageBox("   ");
			m_edit="";UpdateData(false);return;
		}
	}
	CTable base(string("datas\\models.bas"));		//  ,     
	if(!base.Is())
		{
			vector<CColum>types;
			types.push_back(CColum(string("id"),TYPE_INT,AUTO));
			types.push_back(CColum(string("model"),TYPE_SMALLTEXT));
			base.CreateTable(types);
		}
	CRow row;
	row("model",TYPE_SMALLTEXT)=string(m_edit.GetBuffer(100));	
	base.AddRow(row);
	m_list.AddString(m_edit.GetBuffer(100));
	m_list.SelectString(-1,m_edit.GetBuffer(100));
	m_edit="";
	UpdateData(false);
	m_list.SetFocus();
}
/////////////////////////////////////////////////////////////////////////////
//    
//
void CModelList::OnButton2() 
{
	int sel=m_list.GetCurSel();
	if(sel<0)return;
	m_list.GetText(sel,text);
	m_list.DeleteString(sel);
	if(sel<m_list.GetCount()){m_list.SetCurSel(sel);OnSelchangeList1();}
	if((sel==m_list.GetCount())&&(sel!=0)){m_list.SetCurSel(sel-1);OnSelchangeList1();}
	if(m_list.GetCount()==0){m_edit="";UpdateData(false);}
	CTable base(string("datas\\models.bas"));
	if(!base.Is()){MessageBox("  ","Attention");return;}
	base.DeleteData("model",string(text.GetBuffer(100)));
}
////////////////////////////////////////////////////////////////////////////
//,    
//
BOOL CModelList::OnInitDialog() 
{
	CDialog::OnInitDialog();
	vector<CRow>models;
	CTable base(string("datas\\models.bas"));					
		if(!base.Is())
		{
			vector<CColum>types;
			types.push_back(CColum(string("id"),TYPE_INT,AUTO));
			types.push_back(CColum(string("model"),TYPE_SMALLTEXT));
			base.CreateTable(types);
		}
	CRow row;
	base.GetStr(models,"id","");				//   
	for(int i=0;i<models.size();i++)
	{
		row=models[i];
		m_list.AddString(row["model"].c_str());
	}
	return TRUE;
}
///////////////////////////////////////////////////////////////////////////
//   
//
void CModelList::OnButton3() 
{
	int sel=m_list.GetCurSel();
	if(sel<0)return;
	UpdateData();
	if(m_edit.GetLength()<=0)return;
	CString ss;
	for(int i=0;i<m_list.GetCount();i++)
	{	m_list.GetText(i,ss);
		if(!ss.CompareNoCase(m_edit.GetBuffer(100)))
		{
			MessageBox("   ");
			m_edit="";UpdateData(false);return;
		}
	}
	CTable base(string("datas\\models.bas"));
	if(!base.Is()){MessageBox("  ","Attention");return;}
	CRow row;
	m_list.GetText(sel,text);
	row("model",TYPE_SMALLTEXT)=string(m_edit.GetBuffer(100));
	base.ChangeData(row,"model",string(text.GetBuffer(100)));
	m_list.DeleteString(sel);
	m_list.AddString(m_edit.GetBuffer(100));
	m_list.SelectString(-1,m_edit.GetBuffer(100));
	m_edit="";
	UpdateData(false);
	m_list.SetFocus();
}
///////////////////////////////////////////////////////////////////////////
//  OK
//
void CModelList::OnButton4() 
{
	CDialog::OnOK();
}
////////////////////////////////////////////////////////////////////////////
//,       
//
void CModelList::OnSelchangeList1() 
{
	int sel=m_list.GetCurSel();
	CString ss;
	m_list.GetText(sel,ss);
	m_edit=ss;
	UpdateData(false);
}
