// Search.cpp : implementation file
//

#include "stdafx.h"
#include "Autolog.h"
#include "Search.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSearch dialog


CSearch::CSearch(CWnd* pParent /*=NULL*/)
	: CDialog(CSearch::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSearch)
	m_report = _T("");
	//}}AFX_DATA_INIT
}


void CSearch::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSearch)
	DDX_Control(pDX, IDC_COMBO1, m_combo1);
	DDX_Control(pDX, IDC_COMBO2, m_combo2);
	DDX_Control(pDX, IDC_EDIT2, m_edit2);
	DDX_Control(pDX, IDC_EDIT1, m_edit1);
	DDX_Control(pDX, IDC_COMBO3, m_combo3);
	DDX_Text(pDX, IDC_EDIT3, m_report);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSearch, CDialog)
	//{{AFX_MSG_MAP(CSearch)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_CBN_SELCHANGE(IDC_COMBO1, OnSelchangeCombo1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSearch message handlers
/////////////////////////////////////////////////////////////////////////////
//   ""
//
void CSearch::OnButton1() 
{
	CTable base(string("datas\\cars.bas"));
	if(!base.Is())return;
	CString key;
	CString value;
	char buf[4];
	int cur;
	switch(m_combo1.GetCurSel())			//m_combo1-  
	{
		case 0:								//  
			m_edit1.GetLine(0,value.GetBuffer(50),50);
			value.ReleaseBuffer();
			key="number";
			if(value.GetLength()<=0)
			{
				MessageBox("   ","Attention");
				return;
			}
		break;
		case 1:								// 
			m_edit2.GetLine(0,value.GetBuffer(50),50);
			value.ReleaseBuffer();
			key="owner";
			if(value.GetLength()<=0)
			{
				MessageBox("   ","Attention");
				return;
			}	
		;break;
		case 2:								//  
			cur=m_combo3.GetCurSel();
			if(cur<0)
			{
				MessageBox("   ","Attention");
				return;
			}
			m_combo3.GetLBText(cur,value);
			key="model";
		break;
		default:MessageBox("    ","Attention");return;
	}

	vector<CRow>finded;
	vector<CRow>temp;
	CTable base1(string("datas\\stations.bas"));
	CTable base2(string("datas\\districts.bas"));
	if(!base1.Is())return;
	if(!base2.Is())return;
	CRow row,row1;
	int i;
	switch(m_combo2.GetCurSel())			//m_combo2-   
	{
	case 0:base.GetCmp(finded,"did",itoa(dist,buf,10));break;	// 
	case 1:base.GetCmp(finded,"cid",itoa(stat,buf,10));break;	// 
	case 2:base.GetStr(finded,key.GetBuffer(50),value.GetBuffer(50));break;	//
	default:MessageBox("    ","Attention");return;
	}
	int sea=0;
		m_listctrl.DeleteAllItems();//    ,      m_combo1
		for(i=0;i<finded.size();i++)
		{
			row=finded[i];
			if(!strcmp(row[key.GetBuffer(50)].c_str(),value.GetBuffer(50)))// ,  
			{															   //   
				sea++;
				m_listctrl.InsertItem(0,row["number"].c_str());
				m_listctrl.SetItemText(0,1,row["owner"].c_str());
				m_listctrl.SetItemText(0,2,row["model"].c_str());
				temp.clear();
				base1.GetCmp(temp,"id",row["cid"].c_str());
				row1=temp[0];
				m_listctrl.SetItemText(0,3,row1["station"].c_str());
				temp.clear();
				base2.GetCmp(temp,"id",row["did"].c_str());
				row1=temp[0];
				m_listctrl.SetItemText(0,4,row1["district"].c_str());
			}
		}
		m_report=itoa(sea,buf,10)+CString(" cars finded");
		UpdateData(false);
}
////////////////////////////////////////////////////////////////////////////
//,    
//
BOOL CSearch::OnInitDialog() 
{
	CDialog::OnInitDialog();
	CTable base(string("datas\\models.bas"));
	if(!base.Is())
		{
			vector<CColum>types;
			types.push_back(CColum(string("id"),TYPE_INT,AUTO));
			types.push_back(CColum(string("model"),TYPE_SMALLTEXT));
			base.CreateTable(types);
		}
	CRow row;
	vector<CRow>models;
	base.GetStr(models,"id","");
	for(int i=0;i<models.size();i++)
	{
		row=models[i];
		m_combo3.AddString(row["model"].c_str());
	}
	m_combo1.AddString("By number");
	m_combo1.AddString("By owner");
	m_combo1.AddString("By model");
	m_combo2.AddString("This district");
	m_combo2.AddString("This station");
	m_combo2.AddString("Any place");

	m_listctrl.Create(WS_VISIBLE|WS_BORDER|LVS_REPORT,CRect(11,95,522,340), this, 1);
	m_listctrl.SetExtendedStyle(LVS_EX_GRIDLINES|LVS_EX_FULLROWSELECT);
	m_listctrl.InsertColumn(0,"",LVCFMT_LEFT,95);
	m_listctrl.InsertColumn(1,"",LVCFMT_LEFT,100);
	m_listctrl.InsertColumn(2,"",LVCFMT_LEFT,100);
	m_listctrl.InsertColumn(3,"",LVCFMT_LEFT,100);
	m_listctrl.InsertColumn(4,"",LVCFMT_LEFT,100);

	m_combo1.SetCurSel(0);
	m_edit1.EnableWindow();
	m_edit2.EnableWindow(false);
	m_combo3.EnableWindow(false);
	m_combo2.SetCurSel(1);
	return TRUE;  
	              
}
////////////////////////////////////////////////////////////////////////////
//,       id    
//
void CSearch::SetCur(int s,int d)
{
	dist=d;
	stat=s;
}
////////////////////////////////////////////////////////////////////////////
//,   
//
void CSearch::OnSelchangeCombo1() 
{
	switch(m_combo1.GetCurSel())
	{
		case 0:	m_edit1.EnableWindow();m_edit2.EnableWindow(false);m_combo3.EnableWindow(false);break;
		case 1:	m_edit1.EnableWindow(false);m_edit2.EnableWindow();m_combo3.EnableWindow(false);break;
		case 2:	m_edit1.EnableWindow(false);m_edit2.EnableWindow(false);m_combo3.EnableWindow();break;
		default:return;
	}
}
