// AutologDlg.cpp : implementation file
//
#include "stdafx.h"
#include "Autolog.h"
#include "AutologDlg.h"
#include "ModelList.h"
#include "DistrictList.h"
#include "StationList.h"
#include "Search.h"
#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
/*************************************************************
*
*	    c 
*
*************************************************************/
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();
	//{{AFX_DATA(CAboutDlg)
//  IDD  
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};
CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}
void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()
/////////////////////////////////////////////////////////////////////////////
// CAutologDlg dialog
CAutologDlg::CAutologDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAutologDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAutologDlg)
	//    
	m_edit1 = _T("");
	m_edit2 = _T("");
	m_cars = _T("");
	//}}AFX_DATA_INIT
	//  
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CAutologDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAutologDlg)
	//   
	DDX_Control(pDX, IDC_COMBO3, m_combo3);
	DDX_Control(pDX, IDC_COMBO2, m_combo2);
	DDX_Control(pDX, IDC_COMBO1, m_combo1);
	DDX_Text(pDX, IDC_EDIT2, m_edit1);
	DDV_MaxChars(pDX, m_edit1, 50);
	DDX_Text(pDX, IDC_EDIT3, m_edit2);
	DDV_MaxChars(pDX, m_edit2, 50);
	DDX_Text(pDX, IDC_EDIT1, m_cars);
	DDV_MaxChars(pDX, m_cars, 50);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAutologDlg, CDialog)
	//{{AFX_MSG_MAP(CAutologDlg)
	//  
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_COMMAND(MENU_EDITMARKS,OnEditModels)
	ON_COMMAND(MENU_EDITDISTRICTS,OnEditDistrics)
	ON_COMMAND(MENU_EDITPARKS,OnEditParks)
	ON_COMMAND(IDS_ABOUTBOX,OnAbout)
	ON_COMMAND(IDHELP,OnHelp)
	ON_WM_QUERYDRAGICON()
	ON_CBN_SELCHANGE(IDC_COMBO1, OnSelchangeCombo1)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON6, OnButton6)
	ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
	ON_CBN_SELCHANGE(IDC_COMBO2, OnSelchangeCombo2)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAutologDlg message handlers
////////////////////////////////////////////////////////////////////////////
//     
//
void CAutologDlg::OnEditModels()
{
	CModelList*models=new CModelList();
	models->DoModal();
	delete models;
	GetModels();														//    m_combo3   
}
////////////////////////////////////////////////////////////////////////////
//     
//
void CAutologDlg::OnEditDistrics()
{
	int curfolder1=m_combo1.GetCurSel();								//    
	CString dist="",sec="";												//       
	if(curfolder1>=0)													//    m_combo1  -1, 
	{																		
		m_combo1.GetLBText(curfolder1,dist);							//       dist	
		int curfolder2=m_combo2.GetCurSel();							//    
		if(curfolder2>=0)												//   -1, 
		{											
			m_combo2.GetLBText(curfolder2,sec);							//    sec  	
		}
	}
	DistrictList*distr=new DistrictList();								//   
	distr->DoModal();
	delete distr;
	m_listctrl.DeleteAllItems();
	GetDistricts();														//  m_combo1  	
	CString ss;
	m_combo2.ResetContent();											//  	
	for(int i=0;i<districts.size();i++)								    //   m_combo1  m_combo2	
	{																	// ,     .
		m_combo1.GetLBText(i,ss);										// ,   ,  ,   	
		if(ss==dist)													//     			
		{
			m_combo1.SetCurSel(i);
			OnSelchangeCombo1();
			for(i=0;i<stations.size();i++)
			{
				m_combo2.GetLBText(i,ss);
				if(ss==sec)
				{
					m_combo2.SetCurSel(i);
					OnSelchangeCombo2();
				}
			}
		}
	}
	if(districts.size()==0)												//  	
	{			
		GetCars(-2);													//    
	}
}
////////////////////////////////////////////////////////////////////////////
//     
//
void CAutologDlg::OnEditParks()
{
	CString sec,ss;
	int curfolder2=m_combo2.GetCurSel();
	if(curfolder2>=0)
	{
		m_combo2.GetLBText(curfolder2,sec);
	}
	CStationList*stat=new CStationList;
	stat->DoModal();
	delete stat;
	m_listctrl.DeleteAllItems();
	m_combo2.ResetContent();
	OnSelchangeCombo1();
	for(int i=0;i<stations.size();i++)
	{
		m_combo2.GetLBText(i,ss);
		if(ss==sec)
		{
			m_combo2.SetCurSel(i);
			OnSelchangeCombo2();
		}
	}
	if(stations.size()==0)
	{
		GetCars(-2);
	}
}
////////////////////////////////////////////////////////////////////////////
//,    
//
BOOL CAutologDlg::OnInitDialog()
{
	CDialog::OnInitDialog();
	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);
	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
    m_listctrl.Create(WS_VISIBLE|WS_BORDER|LVS_REPORT,CRect(11,125,549,350), this, 1);	//  CListCtr    
    m_listctrl.SetExtendedStyle(LVS_EX_GRIDLINES|LVS_EX_FULLROWSELECT);					//   
	m_listctrl.InsertColumn(0,"",LVCFMT_LEFT,175);									//    
	m_listctrl.InsertColumn(1,"",LVCFMT_LEFT,150);
	m_listctrl.InsertColumn(2,"",LVCFMT_LEFT,205);
	GetModels();																		//  			
	GetDistricts();																		// 			
	char buf[3];
	CTable base(string("datas\\cars.bas"));												// 
	if(!base.Is())return false;															//  ,  	
	m_cars=CString("Base has ")+itoa(base.getrows(),buf,10)+CString(" cars");			//     		
	UpdateData(false);																	//     m_cars

	return TRUE;  // return TRUE  unless you set the focus to a control

}
////////////////////////////////////////////////////////////////////////////
//    
//
void CAutologDlg::OnAbout()
{
	CAboutDlg about;
	about.DoModal();
}
////////////////////////////////////////////////////////////////////////////
//    help
//
void CAutologDlg::OnHelp()
{
	ShellExecute(this->m_hWnd,0,"Help.chm",0,0,SW_SHOWNORMAL);
}
////////////////////////////////////////////////////////////////////////////
//   
//
void CAutologDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}
////////////////////////////////////////////////////////////////////////////
//    
//
void CAutologDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting
		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);
		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;
		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}
//////////////////////////////////////////////////////////////////////////////
// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
//
HCURSOR CAutologDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}
////////////////////////////////////////////////////////////////////////////
//,     
//
void CAutologDlg::OnSelchangeCombo1() 
{
	char buf[3];
	m_listctrl.DeleteAllItems();					//  
	m_combo2.ResetContent();						//  
	stations.clear();								//    
	CTable base(string("datas\\stations.bas"));		// 
	if(!base.Is())return;							//   ,  
	CRow row;
	base.GetCmp(stations,"sid",itoa(GetDistrict(),buf,10));	// ,        m_combo2
	for(int i=0;i<stations.size();i++)
	{
		row=stations[i];
		m_combo2.AddString(row["station"].c_str());
	}	
}
/////////////////////////////////////////////////////////////////////////////
//     
//
void CAutologDlg::GetModels()
{
	m_combo3.ResetContent();						//   
	models.clear();									//     	
	CTable base(string("datas\\models.bas"));		// 
	if(!base.Is())return;							//  ,  		
	CRow row;
	base.GetStr(models,"id","");					//       m_combo3
	for(int i=0;i<models.size();i++)
	{
		row=models[i];
		m_combo3.AddString(row["model"].c_str());
	}
}
/////////////////////////////////////////////////////////////////////////////
//    
//
void CAutologDlg::GetDistricts()
{
	m_combo1.ResetContent();
	districts.clear();
	CTable base(string("datas\\districts.bas"));
	if(!base.Is())return;
	CRow row;
	base.GetStr(districts,"id","");
	for(int i=0;i<districts.size();i++)
	{
		row=districts[i];
		m_combo1.AddString(row["district"].c_str());
	}
}
/////////////////////////////////////////////////////////////////////////////
//   id    
//
int CAutologDlg::GetDistrict()
{
	int curfolder=m_combo1.GetCurSel();			//   
	if(curfolder<0)return -1;					//  0,   -1	
	int size=districts.size();					
	CString ss1;
	m_combo1.GetLBText(curfolder,ss1);			//  
	string ss2=ss1;
	CRow row;
	for(int i=0;i<size;i++)						//  ,    districts	
	{
		row=districts[i];
		if(row["district"]==ss2)
		{
			return atoi(row["id"].c_str());		// id,  
		}
	}
	return -1;
}
/////////////////////////////////////////////////////////////////////////////
//   id    
//
int CAutologDlg::GetStation()
{
	int curfolder=m_combo2.GetCurSel();
	if(curfolder<0)return -1;
	int size=stations.size();
	CString ss1;
	m_combo2.GetLBText(curfolder,ss1);
	string ss2=ss1;
	CRow row;
	for(int i=0;i<size;i++)
	{
		row=stations[i];
		if(row["station"]==ss2)
		{
			return atoi(row["id"].c_str());
		}
	}
	return -1;
}
/////////////////////////////////////////////////////////////////////////////
//    
//
void CAutologDlg::GetCars(int cid)
{																				//     		
	cars.clear();																// 	
	CTable base(string("datas\\cars.bas"));										
	if(!base.Is())return;															
	CRow row;
	cars.clear();
	char buf[3];
	m_listctrl.DeleteAllItems();												//   			
	m_cars=CString("Base has ")+itoa(base.getrows(),buf,10)+CString(" cars");
	UpdateData(false);
	if(cid==-1)base.GetStr(cars,"cid","");										//  cid==-1,     
	if(cid<-1){return;}															// cid<-1,  
	else base.GetCmp(cars,"cid",itoa(cid,buf,10));								//   ,   cid
	for(int i=0;i<cars.size();i++)												// 	
	{
		row=cars[i];
		m_listctrl.InsertItem(0,row["number"].c_str());
		m_listctrl.SetItemText(0,1,row["owner"].c_str());
		m_listctrl.SetItemText(0,2,row["model"].c_str());
	}

}
////////////////////////////////////////////////////////////////
//	   
//
void CAutologDlg::OnButton1() 
{
	if(m_combo1.GetCurSel()<0){MessageBox("   ","Attention");return;}
	if(m_combo2.GetCurSel()<0){MessageBox("   ","Attention");return;}
	if(m_combo3.GetCurSel()<0){MessageBox("   ","Attention");return;}
	UpdateData();
	if(m_edit1.GetLength()<=0){MessageBox("   ","Attention");return;}
	if(m_edit2.GetLength()<=0){MessageBox("   ","Attention");return;}
	char buf[3];
	CTable base(string("datas\\cars.bas"));									// 
		if(!base.Is())														//  ,  
		{
			vector<CColum>types;											// ,     
			types.push_back(CColum(string("id"),TYPE_INT,AUTO));
			types.push_back(CColum(string("model"),TYPE_SMALLTEXT));
			types.push_back(CColum(string("number"),TYPE_SMALLTEXT));
			types.push_back(CColum(string("owner"),TYPE_SMALLTEXT));
			types.push_back(CColum(string("cid"),TYPE_INT));
			types.push_back(CColum(string("did"),TYPE_INT));
			base.CreateTable(types);
		}
	vector<CRow>temp;
	base.GetCmp(temp,"number",m_edit1.GetBuffer(50));						//      m_edit1
	if(temp.size()>0)
	{
		MessageBox("     ");
		return;
	}
	CRow row;
	int curfolder=m_combo3.GetCurSel();										//   ,     
	CString ss1;
	m_combo3.GetLBText(curfolder,ss1);										
	row("model",TYPE_INT)=string(ss1.GetBuffer(100));						//  	
	row("number",TYPE_SMALLTEXT)=string(m_edit1.GetBuffer(100));
	row("owner",TYPE_SMALLTEXT)=string(m_edit2.GetBuffer(100));
	row("cid",TYPE_INT)=itoa(GetStation(),buf,10);
	row("did",TYPE_INT)=itoa(GetDistrict(),buf,10);
	base.AddRow(row);	
	GetCars(GetStation());													//  	
	m_edit1="";
	m_edit2="";
	UpdateData(false);
	m_listctrl.SetFocus();
}
////////////////////////////////////////////////////////////////
//	   
//
void CAutologDlg::OnButton6() 
{
	if(m_combo3.GetCurSel()<0){MessageBox("   ","Attention");return;}
	UpdateData();
	if(m_edit1.GetLength()<=0){MessageBox("   ","Attention");return;}
	if(m_edit2.GetLength()<=0){MessageBox("   ","Attention");return;}
	CTable base(string("datas\\cars.bas"));								// 			
	if(!base.Is()){MessageBox("  ","Attention");return;}
	POSITION pos = m_listctrl.GetFirstSelectedItemPosition();			//  
	if (pos == NULL)
	{
		MessageBox("   ","Attention");
		return;
	}
	else
	{
		CString ss2;
		UpdateData();
		int item=m_listctrl.GetNextSelectedItem(pos);					
		ss2=m_listctrl.GetItemText(item,0);							//   			
		vector<CRow>temp;
		base.GetCmp(temp,"number",m_edit1.GetBuffer(50));			//   	
		if(temp.size()>0)											//  ,  	
		{
			if(ss2!=m_edit1)
			{
			MessageBox(" c    ");
			m_edit1="";
			UpdateData(false);
			return;
			}
		}															//  	
		int curfolder=m_combo3.GetCurSel();
		CString ss1;
		m_combo3.GetLBText(curfolder,ss1);
		char buf[3];
		CRow row;
		row("model",TYPE_SMALLTEXT)=string(ss1.GetBuffer(100));
		row("number",TYPE_SMALLTEXT)=string(m_edit1.GetBuffer(100));
		row("owner",TYPE_SMALLTEXT)=string(m_edit2.GetBuffer(100));
		row("cid",TYPE_INT)=itoa(GetStation(),buf,10);
		row("did",TYPE_INT)=itoa(GetDistrict(),buf,10);
		base.ChangeData(row,"number",ss2.GetBuffer(100));
	}
	GetCars(GetStation());											//  
	m_edit1="";
	m_edit2="";
	UpdateData(false);
	m_listctrl.SetFocus();
}
////////////////////////////////////////////////////////////////
//	   
//
void CAutologDlg::OnButton5() 
{
	CTable base(string("datas\\cars.bas"));
	if(!base.Is()){MessageBox("  ","Attention");return;}
	int nItem;
	POSITION pos = m_listctrl.GetFirstSelectedItemPosition();	//  
	if (pos == NULL)
	{
		MessageBox("   ","Attention");
		return;
	}
	else
	{
		while (pos)												//  			
			{
				nItem = m_listctrl.GetNextSelectedItem(pos);
				base.DeleteData("number",m_listctrl.GetItemText(nItem,0).GetBuffer(100));
			}
	}
	GetCars(GetStation());
}
///////////////////////////////////////////////////////////////
//,     
//
void CAutologDlg::OnSelchangeCombo2() 
{
	GetCars(GetStation());
}
///////////////////////////////////////////////////////////////
//   
//
void CAutologDlg::OnButton2() 
{
	CSearch*search=new CSearch();
	search->SetCur(GetStation(),GetDistrict());
	search->DoModal();
	delete search;
}
