// AutologDlg.h : header file
//

#if !defined(AFX_AUTOLOGDLG_H__F6FF90FB_A64C_4455_906E_5671C67CDBFD__INCLUDED_)
#define AFX_AUTOLOGDLG_H__F6FF90FB_A64C_4455_906E_5671C67CDBFD__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

/////////////////////////////////////////////////////////////////////////////
// CAutologDlg dialog

class CAutologDlg : public CDialog
{
	CComboBox	m_combo3;
	CComboBox	m_combo2;
	CComboBox	m_combo1;
	CString	m_edit1;
	CString	m_edit2;
	CString	m_cars;
public:
	CAutologDlg(CWnd* pParent = NULL);	// standard constructor
	//{{AFX_DATA(CAutologDlg)
	enum { IDD = IDD_AUTOLOG_DIALOG };
	//}}AFX_DATA
	//{{AFX_VIRTUAL(CAutologDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	void GetModels();					//     				
	void GetDistricts();				//    
	void GetCars(int i);				//    
	int GetDistrict();					//   id    
	int GetStation();					//   id    
	HICON m_hIcon;
	CListCtrl	m_listctrl;
	vector<CRow>districts;				//    
	vector<CRow>models;					//     
	vector<CRow>stations;				//    
	vector<CRow>cars;					//    
	// Generated message map functions
	//{{AFX_MSG(CAutologDlg)
	virtual BOOL OnInitDialog();		//,    
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);//   
	afx_msg void OnPaint();				//    
	afx_msg void OnEditModels();		//     
	afx_msg void OnEditDistrics();		//     
	afx_msg void OnEditParks();			//     
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnSelchangeCombo1();	//,     
	afx_msg void OnButton1();			//   
	afx_msg void OnButton6();			//   
	afx_msg void OnButton5();			//   
	afx_msg void OnSelchangeCombo2();	//,     
	afx_msg void OnButton2();			//   
	afx_msg void OnAbout();				//    
	afx_msg void OnHelp();				//    help
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_AUTOLOGDLG_H__F6FF90FB_A64C_4455_906E_5671C67CDBFD__INCLUDED_)
