// DistrictList.cpp : implementation file
//
#include "stdafx.h"
#include "Autolog.h"
#include "DistrictList.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif
/////////////////////////////////////////////////////////////////////////////
// DistrictList dialog
DistrictList::DistrictList(CWnd* pParent /*=NULL*/)
	: CDialog(DistrictList::IDD, pParent)
{
	//{{AFX_DATA_INIT(DistrictList)
	m_edit = _T("");
	//}}AFX_DATA_INIT
}

void DistrictList::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(DistrictList)
	//   
	DDX_Control(pDX, IDC_LIST1, m_list);
	DDX_Text(pDX, IDC_EDIT1, m_edit);
	DDV_MaxChars(pDX, m_edit, 50);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(DistrictList, CDialog)
	//{{AFX_MSG_MAP(DistrictList)
	//  
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_LBN_SELCHANGE(IDC_LIST1, OnSelchangeList1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// DistrictList message handlers
///////////////////////////////////////////////////////////////////////////
//  OK
//
void DistrictList::OnButton4()
{
	CDialog::OnOK();
}
///////////////////////////////////////////////////////////////////////////
//  
//
void DistrictList::OnButton1() 
{
	UpdateData();
	if(m_edit.GetLength()<=0)return;
	CString ss;
	for(int i=0;i<m_list.GetCount();i++)								//     ,  		
	{	m_list.GetText(i,ss);
		if(!ss.CompareNoCase(m_edit.GetBuffer(100)))
		{
			MessageBox("   ","Attention!");m_edit="";UpdateData(false);return;
		}
	}
	CTable base(string("datas\\districts.bas"));						//   
	if(!base.Is())
		{
			vector<CColum>types;
			types.push_back(CColum(string("id"),TYPE_INT,AUTO));
			types.push_back(CColum(string("district"),TYPE_SMALLTEXT));
			base.CreateTable(types);
		}
	CRow row;
	row("district",TYPE_SMALLTEXT)=string(m_edit.GetBuffer(100));	
	base.AddRow(row);
	m_list.AddString(m_edit.GetBuffer(100));
	m_list.SelectString(-1,m_edit.GetBuffer(100));
	m_edit="";
	UpdateData(false);
	m_list.SetFocus();
}
///////////////////////////////////////////////////////////////////////////
//  
//
void DistrictList::OnButton2() 
{
	int sel=m_list.GetCurSel();
	if(sel<0)return;
	CString text;
	vector<CRow>temp;
	CRow row;
	m_list.GetText(sel,text);
	CTable base(string("datas\\districts.bas"));
	if(!base.Is()){MessageBox("  ","Attention");return;}		//  	
	base.GetCmp(temp,"district",string(text.GetBuffer(100)));					//   
	if(temp.size()==0){MessageBox(" :   ","Attention!");return;}
	row=temp[0];
	CTable base2(string("datas\\stations.bas"));								//   
	if(!base2.Is())
	{
		vector<CColum>types;
		types.push_back(CColum(string("id"),TYPE_INT,AUTO));
		types.push_back(CColum(string("station"),TYPE_SMALLTEXT));
		types.push_back(CColum(string("sid"),TYPE_INT));
		base.CreateTable(types);
	}
	temp.clear();
	base2.GetCmp(temp,"sid",row["id"]);											//     ,   sid   id 
	if(temp.size()>0)
	{
		int res=MessageBox("     ?","Attention!",MB_YESNO);
		if(res==IDNO)return;
	}
	m_list.DeleteString(sel);														
	if(sel<m_list.GetCount()){m_list.SetCurSel(sel);OnSelchangeList1();}
	if((sel==m_list.GetCount())&&(sel!=0)){m_list.SetCurSel(sel-1);OnSelchangeList1();}
	if(m_list.GetCount()==0){m_edit="";UpdateData(false);}
	base2.DeleteData("sid",row["id"]);											//  			
	base.DeleteData("district",string(text.GetBuffer(100)));					//   sid=id
	CTable base1(string("datas\\cars.bas"));
	if(!base1.Is())return;
	base1.DeleteData("did",row["id"]);											//   did=id
}
///////////////////////////////////////////////////////////////////////////
//  
//
void DistrictList::OnButton3()
{
	int sel=m_list.GetCurSel();
	if(sel<0)return;
	UpdateData();
	if(m_edit.GetLength()<=0)return;
	CString ss;
	for(int i=0;i<m_list.GetCount();i++)						// t t   ,  		
	{	m_list.GetText(i,ss);
		if(!ss.CompareNoCase(m_edit.GetBuffer(100)))
		{
			MessageBox("   ","Attention!"); 	m_edit="";	UpdateData(false);return;
		}
	}
	CTable base(string("datas\\districts.bas"));
	if(!base.Is()){MessageBox("  ","Attention");return;}
	CRow row;
	CString text;
	m_list.GetText(sel,text);	
	row("district",TYPE_SMALLTEXT)=string(m_edit.GetBuffer(100));		//  
	base.ChangeData(row,"district",string(text.GetBuffer(100)));		//   district=text  
	m_list.DeleteString(sel);
	m_list.AddString(m_edit.GetBuffer(100));
	m_list.SelectString(-1,m_edit.GetBuffer(100));
	m_edit="";
	UpdateData(false);
	m_list.SetFocus();
}
////////////////////////////////////////////////////////////////////////////
//,    
//
BOOL DistrictList::OnInitDialog() 
{
	CDialog::OnInitDialog();
	vector<CRow>models;
	CTable base(string("datas\\districts.bas"));						//  
		if(!base.Is())
		{
			vector<CColum>types;
			types.push_back(CColum(string("id"),TYPE_INT,AUTO));
			types.push_back(CColum(string("district"),TYPE_SMALLTEXT));
			base.CreateTable(types);
		}
	CRow row;
	base.GetStr(models,"id","");
	for(int i=0;i<models.size();i++)
	{
		row=models[i];
		m_list.AddString(row["district"].c_str());
	}
	return TRUE;
}
////////////////////////////////////////////////////////////////////////////
//,      
//
void DistrictList::OnSelchangeList1() 
{
	int sel=m_list.GetCurSel();
	CString ss;
	m_list.GetText(sel,ss);
	m_edit=ss;
	UpdateData(false);
}
