// StationList.cpp : implementation file
//

#include "stdafx.h"
#include "Autolog.h"
#include "StationList.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CStationList dialog


CStationList::CStationList(CWnd* pParent /*=NULL*/)
	: CDialog(CStationList::IDD, pParent)
{
	//{{AFX_DATA_INIT(CStationList)
	m_edit = _T("");
	//}}AFX_DATA_INIT
}


void CStationList::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CStationList)
	DDX_Control(pDX, IDC_LIST1, m_list);
	DDX_Control(pDX, IDC_COMBO1, m_combo);
	DDX_Text(pDX, IDC_EDIT1, m_edit);
	DDV_MaxChars(pDX, m_edit, 100);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CStationList, CDialog)
	//{{AFX_MSG_MAP(CStationList)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_CBN_SELCHANGE(IDC_COMBO1, OnSelchangeCombo1)
	ON_LBN_SELCHANGE(IDC_LIST1, OnSelchangeList1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CStationList message handlers
///////////////////////////////////////////////////////////////////////////
//  OK
//
void CStationList::OnButton4() 
{
	CDialog::OnOK();
}
/////////////////////////////////////////////////////////////////////////////
//   
//
void CStationList::OnButton1() 
{
	UpdateData();
	char buf[3];
	if(m_edit.GetLength()<=0)return;
	if(GetDistrict()<0)return;
	CString ss;
	for(int i=0;i<m_list.GetCount();i++)	//    ,  
	{	m_list.GetText(i,ss);
		if(!ss.CompareNoCase(m_edit.GetBuffer(100)))
		{
			MessageBox("   ");
			m_edit="";UpdateData(false);return;
		}
	}
	CTable base(string("datas\\stations.bas"));
	if(!base.Is())
		{
			vector<CColum>types;
			types.push_back(CColum(string("id"),TYPE_INT,AUTO));
			types.push_back(CColum(string("station"),TYPE_SMALLTEXT));
			types.push_back(CColum(string("sid"),TYPE_INT));
			base.CreateTable(types);
		}
	CRow row;
	row("station",TYPE_SMALLTEXT)=string(m_edit.GetBuffer(100));	
	row("sid",TYPE_INT)=itoa(GetDistrict(),buf,10);
	base.AddRow(row);
	m_list.AddString(m_edit);
	m_list.SelectString(-1,m_edit.GetBuffer(100));
	m_edit="";
	UpdateData(false);
	m_list.SetFocus();
	stations.clear();
	CTable base1(string("datas\\stations.bas"));		//  
	if(!base1.Is())return;
	base1.GetCmp(stations,"sid",itoa(GetDistrict(),buf,10));
}
/////////////////////////////////////////////////////////////////////////////
//   
//
void CStationList::OnButton2() 
{
	int sel=m_list.GetCurSel();
	if(sel<0)return;
	if(GetDistrict()<0)return;
	if(GetStation()<0)return;
	CString text;
	char buf[3];
	CTable base(string("datas\\stations.bas"));			//  
	if(!base.Is()){MessageBox("  ","Attention");return;}
	CTable base1(string("datas\\cars.bas"));
	if(!base1.Is())
	{
			vector<CColum>types;
			types.push_back(CColum(string("id"),TYPE_INT,AUTO));
			types.push_back(CColum(string("model"),TYPE_SMALLTEXT));
			types.push_back(CColum(string("number"),TYPE_SMALLTEXT));
			types.push_back(CColum(string("owner"),TYPE_SMALLTEXT));
			types.push_back(CColum(string("cid"),TYPE_INT));
			types.push_back(CColum(string("did"),TYPE_INT));
			base1.CreateTable(types);
	}
	vector<CRow>temp;
	CRow row;
	base1.GetCmp(temp,"cid",string(itoa(GetStation(),buf,10))); // ,    
	if(temp.size()>0)											// ,   	
	{
		int res=MessageBox("     ?","Attention!",MB_YESNO);
		if(res==IDNO)return;
	}	
	base.DeleteData("id",itoa(GetStation(),buf,10));			// 		
	base1.DeleteData("cid",itoa(GetStation(),buf,10));			// ,    cid=id
	m_list.DeleteString(sel);
	m_edit="";
	UpdateData(false);
	if(sel<m_list.GetCount()){m_list.SetCurSel(sel);OnSelchangeList1();}
	if((sel==m_list.GetCount())&&(sel!=0)){m_list.SetCurSel(sel-1);OnSelchangeList1();}
	if(m_list.GetCount()==0){m_edit="";UpdateData(false);}
	stations.clear();
	if(!base.Is())return;
	base.GetCmp(stations,"sid",itoa(GetDistrict(),buf,10));
}
/////////////////////////////////////////////////////////////////////////////
//     
//
void CStationList::OnButton3()
{
	int sel=m_list.GetCurSel();
	if(sel<0)return;
	if(GetDistrict()<0)return;
	if(GetStation()<0)return;
	char buf[3];
	UpdateData();
	if(m_edit.GetLength()<=0)return;
	CString ss;
	for(int i=0;i<m_list.GetCount();i++)			//    ,  
	{	m_list.GetText(i,ss);
		if(!ss.CompareNoCase(m_edit.GetBuffer(100)))
		{
			MessageBox("   ");m_edit="";
			UpdateData(false);return;
		}
	}
	vector<CRow>models;
	CTable base(string("datas\\stations.bas"));		
	if(!base.Is()){MessageBox("  ","Attention");return;}
	CRow row;
	row.reset();									//   
	row("station",TYPE_SMALLTEXT)=string(m_edit.GetBuffer(100));
	row("sid",TYPE_INT)=itoa(GetDistrict(),buf,10);
	base.ChangeData(row,"id",string(itoa(GetStation(),buf,10)));
	m_list.DeleteString(sel);
	m_list.AddString(m_edit.GetBuffer(100));
	m_list.SelectString(-1,m_edit.GetBuffer(100));
	m_edit="";
	UpdateData(false);
	m_list.SetFocus();
	stations.clear();
	if(!base.Is())return;
	base.GetCmp(stations,"sid",itoa(GetDistrict(),buf,10));
}
/////////////////////////////////////////////////////////////////////////////
// id  
//
int CStationList::GetDistrict()
{
	int curfolder=m_combo.GetCurSel();
	if(curfolder<0)return -1;
	int size=districs.size();
	CString ss1;
	m_combo.GetLBText(curfolder,ss1);
	string ss2=ss1;
	CRow row;
	for(int i=0;i<size;i++)
	{
		row=districs[i];
		if(row["district"]==ss2)
		{
			return atoi(row["id"].c_str());
		}
	}
	return -1;
}
/////////////////////////////////////////////////////////////////////////////
// id  
//
int  CStationList::GetStation()
{
	int curfolder=m_list.GetCurSel();
	if(curfolder<0)return -1;
	int size=stations.size();
	CString ss1;
	m_list.GetText(curfolder,ss1);
	string ss2=ss1;
	CRow row;
	for(int i=0;i<size;i++)
	{
		row=stations[i];
		if(row["station"]==ss2)
		{
			return atoi(row["id"].c_str());
		}
	}
	return -1;
}
////////////////////////////////////////////////////////////////////////////
//,    
//
BOOL CStationList::OnInitDialog() 
{
	CDialog::OnInitDialog();
	CTable base(string("datas\\districts.bas"));
		if(!base.Is())
		{
			vector<CColum>types;
			types.push_back(CColum(string("id"),TYPE_INT,AUTO));
			types.push_back(CColum(string("district"),TYPE_SMALLTEXT));
			base.CreateTable(types);
		}
	base.GetStr(districs,"id","");
	if(districs.size()<=0)
	{
		MessageBox("   ","Attention");OnCancel();
		return false;
	}
	CRow row;
	for(int i=0;i<districs.size();i++)
	{
		row=districs[i];
		m_combo.AddString(row["district"].c_str());
	}
	return TRUE;
}
////////////////////////////////////////////////////////////////////////////
//,     
//
void CStationList::OnSelchangeCombo1() 
{
	char buf[3];
	m_list.ResetContent();
	stations.clear();
	CTable base(string("datas\\stations.bas"));
	if(!base.Is())
	{
		vector<CColum>types;
		types.push_back(CColum(string("id"),TYPE_INT,AUTO));
		types.push_back(CColum(string("station"),TYPE_SMALLTEXT));
		types.push_back(CColum(string("sid"),TYPE_INT));
		base.CreateTable(types);
	}
	CRow row;
	base.GetCmp(stations,"sid",itoa(GetDistrict(),buf,10));
	for(int i=0;i<stations.size();i++)
	{
		row=stations[i];
		m_list.AddString(row["station"].c_str());
	}	
}
////////////////////////////////////////////////////////////////////////////
//,      
//
void CStationList::OnSelchangeList1() 
{
	int sel=m_list.GetCurSel();
	CString ss;
	m_list.GetText(sel,ss);
	m_edit=ss;
	UpdateData(false);	
}
